import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

public class Block extends Objects
{
    private String type;
    private GreenfootImage image;
    private int timer=100;
    private boolean teleport =false;
    private boolean beamstrahl=true;
    GreenfootSound tele = new GreenfootSound("Teleprter3.mp3");
    public Block(String type)
    {
        this.type = type;

        switch(type)
        {
            case "0": image = new GreenfootImage("block.png");//Interactive object
            break;
            case "1": image = new GreenfootImage("g_transparent.png");
            break;
            case "2": image = new GreenfootImage("g_asphalt.png");
            break;
            case "3": image = new GreenfootImage("g_concrete.png");
            break;
            case "4": image = new GreenfootImage("g_dark_stonebrick.png");
            break;
            case "5": image = new GreenfootImage("g_hard_stone.png");
            break;
            case "6": image = new GreenfootImage("g_hard_dirt.png");
            break;
            case "7": image = new GreenfootImage("g_hard_purple_grass.png");
            break;
            case "8": image = new GreenfootImage("g_hard_stone2.png");
            break;
            case "9": image = new GreenfootImage("g_stonebrick.png");
            break;
            case "10": image = new GreenfootImage("g_light_stonebrick.png");
            break;
            case "11": image = new GreenfootImage("g_wooden_planks.png");
            break;      
            case "12": image = new GreenfootImage("g_ash.png");
            break;  
            case "13": image = new GreenfootImage("g_iron_piller_corner.png");
            break;  
            case "14": image = new GreenfootImage("g_iron_piller_horizontal.png");
            break;  
            case "15": image = new GreenfootImage("g_iron_piller_vertical.png");
            break;  
            case "16": image = new GreenfootImage("g_lilagestein.png");
            break;  
            case "17": image = new GreenfootImage("g_metal_connector.png");
            break;  
            case "18": image = new GreenfootImage("g_metal_side.png");
            break;  
            case "19": image = new GreenfootImage("g_metal_up.png");
            break;
            case "20": image = new GreenfootImage("g_sandstone.png");
            break;
            case "21": image = new GreenfootImage("g_dark_sandstone.png");
            break;
            case "38": image = new GreenfootImage("g_schrägerblock1.png");
                break; 
            case "39": image = new GreenfootImage("g_schrägerblock2.png");
                break; 
            case "41": image = new GreenfootImage("g_transparent.png");
            break;
            case "42": image = new GreenfootImage("g_dark_sandstone.png");
            break;
            case "43": image = new GreenfootImage("g_sandstone.png");
            break;
            case "44": image = new GreenfootImage("g_hard_purple_grass_2.png");
            break;
            case "201": image = new GreenfootImage("g_chest_large.png");
            break;  
            case "202": image = new GreenfootImage("g_chest_small.png");
            break; 
            case "203": image = new GreenfootImage("g_neonlampe.png");
            break; 
            case "204": image = new GreenfootImage("g_tent.png");
            break; 
            case "205": image = new GreenfootImage("g_airlock_closed.png");
            break; 
            case "206": image = new GreenfootImage("g_airlock_open.png");
            break; 
            case "207": image = new GreenfootImage("g_computer_1.png");
            break;
            case "208": image = new GreenfootImage("g_computer_2.png");
            break;
            case "209": image = new GreenfootImage("g_lampe.png");
            break;
            case "210": image = new GreenfootImage("g_moderndoor_open.png");
            break;
            case "211": image = new GreenfootImage("g_moderndoor_closed.png");
            break;
            case "212": image = new GreenfootImage("g_steeldoor.png");
            break;
            case "213": image = new GreenfootImage("g_gitterOffen.png");
            break;
            case "214": image = new GreenfootImage("g_gitterZu.png");
            break;
            case "215": image = new GreenfootImage("g_stromkasten.png");
            break;
            case "216": image = new GreenfootImage("g_dreiteiligerbildschirm.png");
            break;
            case "217": image = new GreenfootImage("g_laboratory_cabinet.png");
            break;
            case "218": image = new GreenfootImage("g_ruine.png");
            break;
            case "219": image = new GreenfootImage("g_stuhl.png");
            break;
            case "220": image = new GreenfootImage("g_teleportpad.png");
            break;
            case "221": image = new GreenfootImage("g_tisch.png");
            break;
            case "222": image = new GreenfootImage("g_.waffen_medium_DMR.png");
            break;
            case "223": image = new GreenfootImage("g_.waffen_medium_LMG.png");
            break;
            case "224": image = new GreenfootImage("g_.waffen_medium_SMG.png");
            break;
            case "225": image = new GreenfootImage("g_waffen_heavy_crossbow.png");
            break;
            case "226": image = new GreenfootImage("g_waffen_heavy_laser.png");
            break;
            case "227": image = new GreenfootImage("g_waffen_heavy_launcher.png");
            break;
            case "228": image = new GreenfootImage("h_ship_blue_HD.png");
            break;  
            case "229": image = new GreenfootImage("h_teleportpad.png");
            break; 
            case "230": image = new GreenfootImage("g_steel_door_closed.png");
            break;   
            case "231": image = new GreenfootImage("g_steel_door.png");
            break;      
            case "232": image = new GreenfootImage("h_locker.png");
            break;      
            case "233": image = new GreenfootImage("h_weapon_locker.png");
            break;  
            case "234": image = new GreenfootImage("g_pipe_2.png");
            break;  
            case "235": image = new GreenfootImage("g_pipe_1.png");
            break;  
            case "236": image = new GreenfootImage("h_antenne.png");
            break;  
            case "237": image = new GreenfootImage("g_chest.png");
            break; 
            case "238": image = new GreenfootImage("g_mine3.png");
            break; 
            case "239": image = new GreenfootImage("g_bacta_tank.png");
            break; 
            case "240": image = new GreenfootImage("g_laboratory_lamp.png");
            break;     
            case "241": image = new GreenfootImage("g_laboratory_table.png");
            break;     
            case "242": image = new GreenfootImage("g_whiteblock.png");
            break;     
            case "243": image = new GreenfootImage("game_over.png");
            break;     
            case "244": image = new GreenfootImage("g_mine2.png");
            break;    
            case "245": image = new GreenfootImage("g_mine1.png");
            break; 
            case "246": image = new GreenfootImage("h_cell_signal_green.png");
            break;  
            case "247": image = new GreenfootImage("h_cell_signal_red.png");
            break;  
            case "248": image = new GreenfootImage("h_chair.png");
            break;
            case "249": image = new GreenfootImage("h_table.png");
            break;  
            case "999": image = new GreenfootImage("block.png"); 
            break;
            default : image = new GreenfootImage("block.png"); 
            break;
        }

        this.setImage(image);
    }  

    public void act(){        
        sounds s = null;
        if(type.equals("999")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            List<sounds> k = getWorld().getObjects(sounds.class);
            s = (sounds) k.get(0);
            s.safezone();
            teleport("safezone");
        }

        if(type.equals("1000")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            grafischerteleport();
            teleport = true;
            beamstrahl = false;
        }

        if(type.equals("1001")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            teleport("endless");
        }

        if(type.equals("1002")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            List<sounds> r = getWorld().getObjects(sounds.class);
            s = (sounds) r.get(0);
            s.ship();
            teleport("endless");
        }
        
        if(type.equals("1003")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            List l =getWorld().getObjects(Player.class);
            Player t = (Player) l.get(0);
            t.setLocation(t.getX()+40,t.getY()+210);
        }
        
        if(type.equals("1004")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            List l =getWorld().getObjects(Player.class);
            Player t = (Player) l.get(0);
            t.setLocation(t.getX(),t.getY()-250);
        }
        
        if(type.equals("1005")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            List l =getWorld().getObjects(Player.class);
            Player t = (Player) l.get(0);
            t.setLocation(t.getX()+40,t.getY()+190);
        }
        
        if(type.equals("1006")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            List l =getWorld().getObjects(Player.class);
            Player t = (Player) l.get(0);
            t.setLocation(t.getX(),t.getY()-290);
        }
        
        if(type.equals("1007")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            List l =getWorld().getObjects(Player.class);
            Player t = (Player) l.get(0);
            t.setLocation(t.getX(),t.getY()-250);
        }
        
        if(type.equals("1008")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            List l =getWorld().getObjects(Player.class);
            Player t = (Player) l.get(0);
            t.setLocation(t.getX()+40,t.getY()+210);
        }
        
        if(type.equals("1009")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            teleport("level1.2");
        }
        
        if(type.equals("1010")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            teleport("level1.1");
        }
        
        if(type.equals("1011")&&isTouching(Player.class)&&Greenfoot.isKeyDown("T")){
            teleport("shipworld");
        }

        if(teleport ==true){
            timer--;
        }

        if(timer==0){
            teleport("shipworld");
        }

    }

    public void grafischerteleport(){
        if(beamstrahl==true){
            if(!tele.isPlaying()){
                tele.play();
            }
            //List l = getWorld().getObjects(Arm.class);
            //getWorld().removeObjects(l);
            TeleportAnimation d = new TeleportAnimation();
            getWorld().addObject(d,getX()+20,getY()-110);
        }
    }

    public void teleport(String s)
    {
        Player p = this.getPlayer();
        Items[][] i = p.getInventory();
        Items[] a = p.getAusger();        
        sounds l = null;
        if(s.equals("safezone"))
        {
            List<sounds> k = getWorld().getObjects(sounds.class);
            l = (sounds) k.get(0);
            l.endless();
            SafeZone z = new SafeZone();
            z.setPlayer(p, i, a);
            getWorld().removeObjects(getWorld().getObjects(null));
            Greenfoot.setWorld(z);
            z.moveAll(300);
        }
        else if(s.equals("shipworld"))
        {
            List<sounds> k = getWorld().getObjects(sounds.class);
            l = (sounds) k.get(0);
            l.safezone();
            ShipWorld sw = new ShipWorld();
            sw.setPlayer(p, i, a);
            getWorld().removeObjects(getWorld().getObjects(null));
            Greenfoot.setWorld(sw);            
        }
        else if(s.equals("endless"))
        {
            List<sounds> k = getWorld().getObjects(sounds.class);
            l = (sounds) k.get(0);
            l.safezone();
            Endless e = new Endless();
            e.setPlayer(p, i, a);
            getWorld().removeObjects(getWorld().getObjects(null));
            Greenfoot.setWorld(e);
            e.moveAll(500);
        }
        else if(s.equals("level1.1"))
        {
            Level1_1 sw = new Level1_1();
            sw.setPlayer(p, i, a);
            getWorld().removeObjects(getWorld().getObjects(null));
            Greenfoot.setWorld(sw);    
        }
        else if(s.equals("level1.2"))
        {
            Level1_2 sw = new Level1_2();
            sw.setPlayer(p, i, a);
            getWorld().removeObjects(getWorld().getObjects(null));
            Greenfoot.setWorld(sw);    
        }
    
    }
    
    public Player getPlayer()
    {
        java.util.List l = getWorld().getObjects(Player.class);
        Player p = (Player) l.get(0);
        return p;
    }

    public int getWidth()
    {
        return image.getWidth();
    }

    public int getHeight()
    {
        return image.getHeight();
    }

    public String getType()
    {
        return type;
    }
}
