import greenfoot.*;
import java.io.*;
import java.util.List;
public class Endless extends World implements Serializable
{  
    private int[][] world;    
    private int breite;
    private int höhe;
    private int blocksize;
    private int xPos;
    //speichern
    private double x;
    private double y;
    private Player player = new Player();
    private Spawntable s;

    private int level;
    public Endless()
    {    
        super(1280, 720, 1, false); 
        breite = 800;
        höhe = 36;
        blocksize = 20;
        xPos = 0;   
        level = 5;
        s = new Spawntable(breite, höhe);
        addObject(player, 640,400);
        prepare();
        prepareWorld();
        setPaintOrder(Weapons.class,Armor.class, HeroesPhys.class,Arm.class, Background.class, Block.class, Enemy.class, Buttons.class, BackgroundbBlocks.class);
        addObject(new sounds(),0,0);
    }

    public Endless(int level)
    {    
        super(1280, 720, 1, false); 
        breite = 800;
        höhe = 36;
        blocksize = 20;
        xPos = 0;  
        this.level = level;
        s = new Spawntable(breite, höhe);
        addObject(player, 640,400);
        prepare();
        prepareWorld();
        setPaintOrder(Weapons.class,Armor.class, HeroesPhys.class,Arm.class, Background.class, Block.class, Enemy.class, Buttons.class, BackgroundbBlocks.class);
        addObject(new sounds(),0,0);
    }

    public void act(){
        moveAll();
    }

    public void setBlock(int b, int h, int block){
        if(breite > b && höhe > h && b >= 0 && h >= 0){
            world[b][h] = block ;
        }
    }

    public int getBlock2(int x, int y){
        int x2 = -1;
        int y2 = -1;
        if(x > 0 && x < breite){
            x2 = x;
        }
        if(y > 0 && y < höhe){
            y2 = y;
        }
        if(x2 >= 0 && y2 >= 0){
            return world[x2][y2];
        }
        else{
            return -1;
        }
    }

    public int getBlock(int breite, int höhe){
        if(this.breite < breite && this.höhe < höhe && breite >= 0 && höhe >= 0){
            return world[breite][höhe];
        }
        else{
            return -999;
        }
    }

    public void showWorld(){

        for(int x = 0; x < breite; x++){
            for(int y = 0; y < höhe; y++){
                int block = world[x][y];
                int xCoord = x * 20 + 10;
                int yCoord = y * 20 + 10;

                switch(block){
                    case 0 : break;
                    default : addObject(new Block(Integer.toString(block)),xCoord, yCoord ); break;

                }
            }
        }
    }

    public void moveAll(){
        int j = (int) player.moveHorizontal();
        moveAll(j); 

    }

    public void moveAll(int q)
    {
        int j = q;
        java.util.List l = getObjects(Block.class);

        for(int i = 0; i < l.size(); i++)
        {
            Block b = (Block) l.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }
        java.util.List w = getObjects(Items.class);
        
        for(int x = 0; x < w.size(); x++)
        {            
            Items y = (Items) w.get(x);
            if(y.statusGeben()==0){
                y.setLocation(y.getX() - j , y.getY());
            }        
        }

        java.util.List m = getObjects(Hostile.class);

        for(int x = 0; x < m.size(); x++)
        {
            Hostile p = (Hostile) m.get(x);
            p.setLocation(p.getX() - j , p.getY());
        }
        
        java.util.List u = getObjects(Interactive.class);

        for(int i = 0; i < u.size(); i++)
        {
            Interactive b = (Interactive) u.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }
        
        java.util.List ship = getObjects(Buttons.class);
        
        for(int i = 0; i < ship.size(); i++)
        {
            Buttons s = (Buttons) ship.get(i);
            s.setLocation(s.getX() - j , s.getY());
        } 
        
        m = getObjects(Background.class);

        for(int x = 0; x < m.size(); x++)
        {
            Background b = (Background) m.get(x);
            b.setLocation(b.getX() - j , b.getY());
        }
        m = getObjects(DeathAnimation.class);
        
        for(int x = 0; x < m.size(); x++)
        {
            DeathAnimation d = (DeathAnimation) m.get(x);
            d.setLocation(d.getX() - j , d.getY());
        }
        m = getObjects(Lootbag.class);
        
        for(int x = 0; x < m.size(); x++)
        {
            Lootbag lo = (Lootbag) m.get(x);
            lo.setLocation(lo.getX() - j , lo.getY());
        }
        m = getObjects(BackgroundbBlocks.class);
        
        for(int x = 0; x < m.size(); x++)
        {
            BackgroundbBlocks ba = (BackgroundbBlocks) m.get(x);
            ba.setLocation(ba.getX() - j , ba.getY());
        }
    }
    //BlockSpawn

    public void testAir(){
        for(int x = 0; x < breite; x++){
            for(int y = 1; y < höhe; y++){

                if(world[x][y] !=0){
                    if(world[x][y-1] == 0){
                        world[x][y] = 20;

                        if(Greenfoot.getRandomNumber(100)< 60 && getBlock2(x - 1, y) == 20){
                            if(Greenfoot.getRandomNumber(2)==0){
                                addObject(new Background(0), x * blocksize, (y-1) * blocksize);
                            }
                            else{
                                addObject(new Background(1), x * blocksize, (y-1) * blocksize + blocksize/2);
                            }
                        }
                    }
                    if(y > 2){
                        if(world[x][y-1] == 0){
                            world[x][y] = 20;
                        }
                        if(world[x][y-1] == 20){
                            world[x][y] = 20;
                        }

                        if(world[x][y-3] == 0 && world[x][y-2] == 20 && world[x][y-1] == 20){
                            world[x][y] = 20;
                        }
                        if(world[x][y-3] == 20 && world[x][y-2] == 20 && world[x][y-1] == 20){
                            world[x][y] = 21;
                        }
                        if(world[x][y-1] == 21){
                            world[x][y] = 21;
                        }
                    }
                }
            }
        }
    }

    private void createWalls(){
        int x = 33;
        for(int y = 0; y < höhe; y ++){
            if(world[x][y] == 0){
                world[x][y] = 41;
            }
        }
        x = breite - 33;
        for(int y = 0; y < höhe; y ++){
            if(world[x][y] == 0){
                world[x][y] = 41;
            }
        }
    }

    public void setPlayer(Player p, Items[][] i, Items[] a)
    {
        this.player = p;
        removeObjects(getObjects(Player.class));
        addObject(p, 640, 350);
        p.aenderungSetzen();
        p.setFirstAct();
        p.setInventory(i);
        p.setAusger(a);
    }

    public void prepareWorld(){
        world = s.getCreateWorld();
        testAir();
        //world[breite - 34][32] = 999;
        createWalls();
        showWorld();
        prepareBGStructures();
        prepareEnemys();
        moveAll(60);
    }

    private void prepareBGStructures(){
        Pointer p = new Pointer();
        addObject(p,0,0);
        for(int i = 10; i < breite * blocksize; i = i + 20){
            int random = Greenfoot.getRandomNumber(100);
            if(random < 10){
                int random2 = Greenfoot.getRandomNumber(80)+1;
                for(int j = 0; j < höhe * blocksize; j = j + random2){
                    p.setLocation(i,j);
                    random2 = Greenfoot.getRandomNumber(80)+1;
                    boolean b = true;
                    if(p.touching()){
                        int y = 0;
                        while(b){
                            int yKoordinate = j - y;
                            if(!p.touching() && j > 0){
                                setStructure(i,yKoordinate + 1);
                                b = false;
                                j = 720;
                            }
                            p.setLocation(i,yKoordinate);

                            y++;
                        }
                    }
                }
            }
        }
        
        for(int i2 = 0; i2 < breite * blocksize; i2 = i2 + 20){
            int random = Greenfoot.getRandomNumber(100);
            if(random < 1){
                int object = Greenfoot.getRandomNumber(5);
                BackgroundbBlocks b = new BackgroundbBlocks(object);
                addObject(b, i2, ((höhe - 3) * 20) - b.getHeight());
                i2 = i2 + b.getWidth();
            }

        }
        removeObject(p);
    }

    private void setStructure(int x, int y){
        int random = Greenfoot.getRandomNumber(12) + 3;

        Background bg = new Background(random);
        int height = bg.getHeight();
        int width = bg.getWidth();

        addObject(bg, x + width, y - height);

    }

    public void prepareEnemys(){
        
        if(level < 10){
            int geschätzeMengeAnGegnern = (int) (((level * 1.5 + 9) * 1.05) - (level * 1.01));

            int variation = (int) (geschätzeMengeAnGegnern * 0.4);

            int mengeAnGegnern = Greenfoot.getRandomNumber(variation) - ((int) ((variation / 2) - 1)) + geschätzeMengeAnGegnern;

            for(int gegner = 0; gegner <= mengeAnGegnern; gegner++){
                int x = Greenfoot.getRandomNumber(breite * blocksize);
                int y = Greenfoot.getRandomNumber((höhe-9) * blocksize);
                if(Greenfoot.getRandomNumber(4) < 3){
                    addObject(new Enemy3(), x, 0);
                }
                else{
                    addObject(new Enemy(), x, 0);
                }
            }
        }
        if(level >= 10 && level < 20){

        }
        if(level > 30){

        }
    }

    private void prepare()
    {
        Dolch dolch = new Dolch(1);
        addObject(dolch,640,532);
        Block horst = new Block ("999");
        addObject(horst, 15320, 648);
        Buttons b = new Buttons ("g_sign_blue.png");
        addObject(b, 15320, 612);
    }
}
