import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class HostilePhys extends Hostile
{
    private Bottom b;
    private Top t;
    private Left l;
    private Right r;

    private int width;
    private int height;

    private int health = 10;
    private int dmg;

    private boolean firstAct = true;
    private boolean ableToJump = true;
    private boolean inJump = false;

    private int gravity = 10;
    private int speed = 2;

    private int jumpheight =15;
    private int normalSpeed = 2;
    private int jumptimer = 10000;
    private int timer;
    private int dir = -1;
    
    private int killtimer = 0;
    
    private GreenfootImage bild;
    private GreenfootImage bildr;
    private GreenfootImage bildl;
    
    //Versuch Animation
    private GreenfootImage steponel;
    private GreenfootImage steptwol;
    private GreenfootImage stepthreel;
    private GreenfootImage steponer;
    private GreenfootImage steptwor;
    private GreenfootImage stepthreer;
    private GreenfootImage standr;
    private GreenfootImage standl;
    
    //Ende Animation
    
    private String name;
    public HostilePhys(){
        b = new Bottom();
        r = new Right();
        l = new Left();
        t = new Top();
        if(this instanceof Enemy3){
            r.getImage().scale(1,32);
            l.getImage().scale(1,32);
        }
        setImage(bild);
    }

    public void act() 
    {
        if(firstAct){
            World w = getWorld();
            w.addObject(b,getX(),getY()+35);
            w.addObject(t,getX(),getY()-35);
            w.addObject(r,getX()+10,getY());
            w.addObject(l,getX()-10,getY());
            firstAct = false;
        }
        // Add your action code here.
        checkGroundTop();
        checkLeftRight();
        jumptimer++;
        moveBarriers();
        changeImage();
        testDeath();
    }   
    
    public int getHealth(){
        return health;
    }
    
    public void setName(String name){
        this.name = name;
        bildl = new GreenfootImage(name+"_l.png");
        bildr = new GreenfootImage(name+"_r.png");
    }
    
    public void setHealth(int i){
        health = i;
    }
    
    public void setAbleToJump(boolean b){
        ableToJump = b;
    }
    public void setImage2(GreenfootImage i){
        bild = i;
        setImage(bild);
    }
    
    public double moveUD(){
        double d = 0;
        if(inJump && b.touching()){
            inJump = false;
        }
        
        if(!inJump && ableToJump){
            if(Greenfoot.getRandomNumber(100) <= 1){
                inJump = true;
                jumptimer = 0;

                d = 20;
            }
        }
        else{
            d = jumpheight-jumptimer*0.2;
        }

        double currentGravity = gravity - d;
        if(currentGravity > 10){
            currentGravity = 10;

        }
        
        if(b.touching() && currentGravity >= 0){

            return 0;
        }
        else{
            return currentGravity;
        }
    }

    public void checkGroundTop(){
        double d = moveUD();
        int x1 = b.getX();
        int y1 = b.getY();
        int x2 = t.getX();
        int y2 = t.getY();
        if(d > 0){
            for(int j = 0;j < d; j++){
                b.setLocation(x1,y1+j);
                if(b.touching()){
                    d = j;
                }
            }
        }
        
        if(d <= 0){
            for(int j = 0;j > d; j--){
                t.setLocation(x2,y2+j);
                if(t.touching()){
                    d = j;
                }
            }
        }

        setLocation(getX(),getY()+d);
    }

    public void moveBarriers(){
        b.setLocation(getX(),getY()+35);
        t.setLocation(getX(),getY()-35);
        r.setLocation(getX()+10,getY());
        l.setLocation(getX()-10,getY());
        if(this instanceof Enemy3){
            b.setLocation(getX(),getY()+17);
            t.setLocation(getX(),getY()-17);
            r.setLocation(getX()+32,getY());
            l.setLocation(getX()-32,getY());
        }
    }

    public void moveLR(){
        int random;

        if(timer > 50 && !inJump){
            random = Greenfoot.getRandomNumber(100);
            if(random < 2){
                if(Greenfoot.getRandomNumber(2) == 0){
                    dir = -dir;
                }
                timer = 0;
            }
        }
        timer++;

    }

    public void checkLeftRight(){
        moveLR();
        int direction = speed;
        if(dir > 0){
            for(int k = 0;k < direction; k= k+5){
                r.setLocation(r.getX()+k,r.getY());
                if(r.touching()){
                    speed = 0;
                    dir = -dir;
                    timer = 0;
                }
            }
        }
        
        if(dir <= 0){
            for(int k = 0;k > -direction; k= k-5){
                l.setLocation(l.getX()+k,l.getY());
                if(l.touching()){
                    speed = 0;
                    dir = -dir;
                    timer = 0;
                }
            }
        }
        setLocation(getX() + (dir*speed),getY());
        speed = normalSpeed;
    }
    
    public void testDeath(){
        if(getHealth() <= 0){
            DeathAnimation d = new DeathAnimation();
            getWorld().addObject(d,getX(),getY());
            
            getWorld().removeObject(b);
            getWorld().removeObject(t);
            getWorld().removeObject(l);
            getWorld().removeObject(r);
            
            getWorld().removeObject(this);
        }
    }
    
    private void changeImage(){
        String s;
        if(dir > 0){
            setImage(bildr);
        }
        else{
            setImage(bildl);
        }
    }
    
    public boolean touchingWeapon(){
        if(isTouching(Weapons.class) || isTouching(Arm.class)){
            return true;
        }
        else{
            return false;
        }
    }
}