import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.util.List.*;

public class Level1_1 extends World
{
    private int[][] world;

    private int breite;
    private int höhe;

    private int xPos;
    //speichern
    private double x;
    private double y;
    private Player player = new Player();

    private String[][] worldMatrix;
    private int worldWidth;
    private int worldHeight;
    private int blocksize = 20;
    private String seed;
    private int counter = 0;
    private String seed_save = "";
    private Block start = new Block("1");
    private Block heinrich = new Block("1003");
    private Block horst = new Block("1004");
    private Block hildegard = new Block("1005");
    private Block hermann = new Block("1006");
    private Block hendrik = new Block("1007");
    private Block henrietta = new Block("1008");
    private Block hanibal = new Block("1009");
    
    private boolean touchpad =false;
    
    public Level1_1()
    {
        super(1280, 720, 1, false);
        worldWidth = 800;
        worldHeight = 37;
        worldMatrix = new String[worldWidth][worldHeight];
        addObject(start, 0, 0);
        setPaintOrder(Weapons.class,Armor.class, HeroesPhys.class,Arm.class);
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                worldMatrix[x][y] = "";
            }
        }

        prepare();
        prepareWorld();
    }

    public void prepare()
    {
        addObject(heinrich, 130,218);
        addObject(horst, 130, 438);
        addObject(hildegard, 660,438);
        addObject(hermann, 660,638);
        addObject(hendrik,2250,438);
        addObject(henrietta, 2250, 238);
        addObject(hanibal,3000,440);
        loadScreen();
        //erster Raum
        Background a = new Background(33);
        addObject(a, 210,570);
        Background b = new Background(33);
        addObject(b, 280,570);
        Background c = new Background(33);
        addObject(c, 350,570);
        Background d = new Background(33);
        addObject(d, 420,570);
        Background e = new Background(33);
        addObject(e, 490,570);
        Background f = new Background(33);
        addObject(f, 830,570);
        Background g = new Background(33);
        addObject(g, 900,570);
        Background h = new Background(33);
        addObject(h, 970,570);
        Background i = new Background(33);
        addObject(i, 1040,570);
        Background j = new Background(33);
        addObject(j, 1110,570);
        Background k = new Background(35);
        addObject(k, 660,620);
        Background l = new Background(35);
        addObject(l, 660,420);
        Background m = new Background(35);
        addObject(m, 130,420);
        Background n = new Background(35);
        addObject(n, 130,200);
        Background o = new Background(38);
        addObject(o, 350,190);
        Background p = new Background(38);
        addObject(p, 550,190);
        Background q = new Background(39);
        addObject(q, 300,190);
        Background r = new Background(39);
        addObject(r, 500,190);
        Background s = new Background(37);
        addObject(s, 1230,350);
        Background t = new Background(40);
        addObject(t, 1030,120);
        Background u = new Background(41);
        addObject(u, 1130,370);
        Background v = new Background(42);
        addObject(v, 890,120);
        Background w = new Background(34);
        addObject(w, 670,150);
        Background x = new Background(34);
        addObject(x, 570,370);
        Background y = new Background(34);
        addObject(y, 770,370);
        Background z = new Background(34);
        addObject(z, 570,570);
        Background aa = new Background(34);
        addObject(aa, 770,570);
        //Gang
        Background  ab= new Background(43);
        addObject(ab, 1440,340);
        Background ac = new Background(43);
        addObject(ac, 1680,340);
        Background ad = new Background(43);
        addObject(ad, 1920,340);
        //zweiter Raum und Aufzug
        Background ae = new Background(35);
        addObject(ae, 2250,220);
        Background af = new Background(35);
        addObject(af, 2250,420);
        Background ag = new Background(30);
        addObject(ag, 2450,170);
        Background ah = new Background(31);
        addObject(ah, 2550,170);
        Background ai = new Background(44);
        addObject(ai, 2630,170);
        Background aj = new Background(44);
        addObject(aj, 2670,170);
        Background ak = new Background(44);
        addObject(ak, 2710,170);
        Background al = new Background(44);
        addObject(al, 2750,170);
        Background am = new Background(45);
        addObject(am, 2920,170);
        
        //Gegner und Interaktive Objekte
        Keycard key = new Keycard();
        addObject (key,1100,190);
        Enemy2 e1 = new Enemy2();
        addObject (e1, 1500, 350);
        Enemy2 e2 = new Enemy2();
        addObject(e2, 2800, 350);
        Enemy2 e3 = new Enemy2();
        addObject (e3, 2200,150);
        Enemy2 e4 = new Enemy2();
        addObject(e4, 1050,150);
        addObject(player, 640,595); 
    }

    public String convertSeed()
    {
        String seed_sub = "";
        String seed_write = "";

        seed_sub = seed.substring(counter, counter+1);
        seed_save = seed_save + seed_sub;
        counter = counter+1;
        seed_sub = (String) seed.substring(counter, counter+1);

        if(seed_sub.equals("/"))
        {
            seed_write = seed_save;
            seed_save = "";
            counter++;
            return seed_write;
        }
        else
        {
            return convertSeed();
        }
    }

    public void loadWorldMatrix()
    {
        String seed_sub = "";
        String seed_save = "";
        String seed_matrix = "";

        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                seed_matrix = convertSeed();
                if(seed_matrix.equals("0"))
                {
                    worldMatrix[x][y] = "";
                }
                else
                {
                    worldMatrix[x][y] = seed_matrix;
                }
            }
        }

        counter = 0;
        setWorld();
    }

    public void setWorld()
    {        
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                if(!worldMatrix[x][y].equals(""))
                {
                    Block block = new Block(worldMatrix[x][y]);
                    int height = block.getHeight();
                    int width = block.getWidth();
                    int width_round = (int) Math.round(width/blocksize + 0.5) * blocksize;
                    int height_round = (int) Math.round(height/blocksize + 0.5) * blocksize;
                    int width_adjusted = (blocksize - (width_round - width))*2;
                    int height_adjusted = (blocksize - (height_round - height))*2;

                    if(Integer.parseInt(worldMatrix[x][y]) < 200)
                    {
                        addObject(new Block(worldMatrix[x][y]), x*blocksize, y*blocksize);
                    }
                    else
                    {
                        if((height % blocksize) == 0)
                        {
                            addObject(new Block(worldMatrix[x][y]), x*blocksize +blocksize/2, y*blocksize +blocksize/2);
                        }
                        else
                        {
                            addObject(block, x*blocksize - width_adjusted + blocksize, y*blocksize + height_adjusted);
                        } 
                    }
                }
            }
        }
    }

    public void showWorld(){

        for(int x = 0; x < breite; x++){
            for(int y = 0; y < höhe; y++){
                int block = world[x][y];
                int xCoord = x * 20 + 10;
                int yCoord = y * 20 + 10;

                switch(block){
                    case 0 : break;
                    default : addObject(new Block(Integer.toString(block)),xCoord, yCoord ); break;

                }
            }
        }
    }

    public void loadScreen()
    {     
        try
        {
            seed = "";
            ObjectInputStream seed_in = new ObjectInputStream(new FileInputStream("level1.4" + ".txt"));
            seed = (String) seed_in.readObject();
            seed_in.close();
        }
        catch(Exception e) 
        {
            System.out.println("Deserialization failed");
            System.out.println();
        }

        loadWorldMatrix();
    }

    public void moveAll()
    {
        int j = (int) player.moveHorizontal();
        java.util.List l = getObjects(Block.class);

        for(int i = 0; i < l.size(); i++)
        {
            Block b = (Block) l.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }

        java.util.List k = getObjects(Armor.class);

        for(int x = 0; x < k.size(); x++)
        {            
            Items y = (Armor) k.get(x);
            if(y.statusGeben()==0){
                y.setLocation(y.getX() - j , y.getY());
            }        
        }

        java.util.List w = getObjects(Weapons.class);

        for(int x = 0; x < w.size(); x++)
        {
            Items p = (Weapons) w.get(x);
            if(p.statusGeben()==0){
                p.setLocation(p.getX() - j , p.getY());
            }
        }

        java.util.List f = getObjects(Potions.class);

        for(int x = 0; x < f.size(); x++)
        {            
            Items p = (Potions) f.get(x);
            if(p.statusGeben()==0){
                p.setLocation(p.getX() - j , p.getY());
            }
        }

        java.util.List m = getObjects(Hostile.class);

        for(int x = 0; x < m.size(); x++)
        {
            Hostile p = (Hostile) m.get(x);
            p.setLocation(p.getX() - j , p.getY());
        }

        java.util.List u = getObjects(Interactive.class);

        for(int i = 0; i < u.size(); i++)
        {
            Interactive b = (Interactive) u.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }

        java.util.List v = getObjects(Background.class);

        for(int i = 0; i < v.size(); i++)
        {
            Background b = (Background) v.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }

        java.util.List ship = getObjects(Buttons.class);

        for(int i = 0; i < ship.size(); i++)
        {
            Buttons s = (Buttons) ship.get(i);
            s.setLocation(s.getX() - j , s.getY());
        }  
        
        java.util.List x = getObjects(Keycard.class);

        for(int i = 0; i < x.size(); i++)
        {
            Keycard s = (Keycard) x.get(i);
            s.setLocation(s.getX() - j , s.getY());
        }  
        
        m = getObjects(Lootbag.class);
        
        for(int y = 0; y < m.size(); y++)
        {
            Lootbag lo = (Lootbag) m.get(y);
            lo.setLocation(lo.getX() - j , lo.getY());
        }
        
        java.util.List q = getObjects(DeathAnimation.class);
        
        for(int z = 0; z < q.size(); z++)
        {
            DeathAnimation d = (DeathAnimation) q.get(z);
            d.setLocation(d.getX() - j , d.getY());
        }
    }

    public void setPlayer(Player p, Items[][] i, Items[] a)
    {
        this.player = p;
        removeObjects(getObjects(Player.class));
        addObject(p, 640, 350);
        p.aenderungSetzen();
        p.setFirstAct();
        p.setInventory(i);
        p.setAusger(a);
    }

    public void act()
    {
        moveAll();
        java.util.List l = getObjects(Keycard.class);
        //Keycard k = (Keycard) l.get(0);
        //if(k.getCardreader() == true){
        //    world[20][10]=0;          
        //    removeObject(k);
        //}
        
    }

    public void prepareWorld(){
        showWorld();
    }

}