import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.util.List.*;

public class Level1_2 extends World
{
    private int[][] world;

    private int breite;
    private int höhe;

    private int xPos;
    //speichern
    private double x;
    private double y;
    private Player player = new Player();

    private String[][] worldMatrix;
    private int worldWidth;
    private int worldHeight;
    private int blocksize = 20;
    private String seed;
    private int counter = 0;
    private String seed_save = "";
    private Block start = new Block("1");
    private Block hendrik = new Block("1007");
    private Block henrietta = new Block("1008");
    private Block hanibal = new Block("1011");

    public Level1_2()
    {    
        super(1280, 720, 1, false);
        worldWidth = 800;
        worldHeight = 37;
        worldMatrix = new String[worldWidth][worldHeight];
        addObject(start, 0, 0);
        setPaintOrder(Weapons.class,Armor.class, HeroesPhys.class,Arm.class);
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                worldMatrix[x][y] = "";
            }
        }

        prepare();
        prepareWorld();
    }

    public void prepare()
    {
        addObject(hendrik,740,478);
        addObject(henrietta, 740, 278);
        addObject(hanibal, 3000, 438);
        loadScreen();
        //Komando Raum
        Background a = new Background(46);
        addObject(a, 2900,420);
        Background b = new Background(46);
        addObject(b, 3100,420);
        Background c = new Background(46);
        addObject(c, 3300,420);
        Background d = new Background(46);
        addObject(d, 3500,420);
        Background e = new Background(46);
        addObject(e, 2900,220);
        Background f = new Background(46);
        addObject(f, 3100,220);
        Background g = new Background(46);
        addObject(g, 3300,220);
        Background h = new Background(46);
        addObject(h, 3500,220);
        Background i = new Background(40);
        addObject(i, 3000,340);
        Background j = new Background(42);
        addObject(j, 3000,120);
        Background k = new Background(40);
        addObject(k, 3420,120);
        Background l = new Background(42);
        addObject(l, 3420,340);
        //Gang
        Background  m= new Background(43);
        addObject(m, 1590,340);
        Background n = new Background(43);
        addObject(n, 1830,340);
        Background o = new Background(43);
        addObject(o, 2070,340);
        Background  p= new Background(43);
        addObject(p, 2310,340);
        Background q = new Background(43);
        addObject(q, 2550,340);
        
        //Fight Room
        Background r = new Background(35);
        addObject(r, 740,260);
        Background s = new Background(35);
        addObject(s, 740,460);
        Background ag = new Background(30);
        addObject(ag, 420,210);
        Background ai = new Background(44);
        addObject(ai, 500,210);
        Background ah = new Background(31);
        addObject(ah, 580,210);
        Background aj = new Background(44);
        addObject(aj, 900,210);
        Background ak = new Background(44);
        addObject(ak, 960,210);
        Background al = new Background(44);
        addObject(al, 1020,210);
        Background am = new Background(31);
        addObject(am, 1100,210);
        //Gegner und Interaktionsobjekte
        Enemy2 e1 = new Enemy2();
        addObject (e1, 1300, 150);
        Enemy2 e2 = new Enemy2();
        addObject(e2, 2800, 350);
        Enemy2 e3 = new Enemy2();
        addObject (e3, 2200,350);
        Enemy2 e4 = new Enemy2();
        addObject(e4, 1050,350);
        Enemy e5 = new Enemy();
        addObject(e5, 3300,350);
        addObject(player, 640,438); 
    }

    public String convertSeed()
    {
        String seed_sub = "";
        String seed_write = "";

        seed_sub = seed.substring(counter, counter+1);
        seed_save = seed_save + seed_sub;
        counter = counter+1;
        seed_sub = (String) seed.substring(counter, counter+1);

        if(seed_sub.equals("/"))
        {
            seed_write = seed_save;
            seed_save = "";
            counter++;
            return seed_write;
        }
        else
        {
            return convertSeed();
        }
    }

    public void loadWorldMatrix()
    {
        String seed_sub = "";
        String seed_save = "";
        String seed_matrix = "";

        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                seed_matrix = convertSeed();
                if(seed_matrix.equals("0"))
                {
                    worldMatrix[x][y] = "";
                }
                else
                {
                    worldMatrix[x][y] = seed_matrix;
                }
            }
        }

        counter = 0;
        setWorld();
    }

    public void setWorld()
    {        
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                if(!worldMatrix[x][y].equals(""))
                {
                    Block block = new Block(worldMatrix[x][y]);
                    int height = block.getHeight();
                    int width = block.getWidth();
                    int width_round = (int) Math.round(width/blocksize + 0.5) * blocksize;
                    int height_round = (int) Math.round(height/blocksize + 0.5) * blocksize;
                    int width_adjusted = (blocksize - (width_round - width))*2;
                    int height_adjusted = (blocksize - (height_round - height))*2;

                    if(Integer.parseInt(worldMatrix[x][y]) < 200)
                    {
                        addObject(new Block(worldMatrix[x][y]), x*blocksize, y*blocksize);
                    }
                    else
                    {
                        if((height % blocksize) == 0)
                        {
                            addObject(new Block(worldMatrix[x][y]), x*blocksize +blocksize/2, y*blocksize +blocksize/2);
                        }
                        else
                        {
                            addObject(block, x*blocksize - width_adjusted + blocksize, y*blocksize + height_adjusted);
                        } 
                    }
                }
            }
        }
    }

    public void showWorld(){

        for(int x = 0; x < breite; x++){
            for(int y = 0; y < höhe; y++){
                int block = world[x][y];
                int xCoord = x * 20 + 10;
                int yCoord = y * 20 + 10;

                switch(block){
                    case 0 : break;
                    default : addObject(new Block(Integer.toString(block)),xCoord, yCoord ); break;

                }
            }
        }
    }

    public void loadScreen()
    {     
        try
        {
            seed = "";
            ObjectInputStream seed_in = new ObjectInputStream(new FileInputStream("level1.2" + ".txt"));
            seed = (String) seed_in.readObject();
            seed_in.close();
        }
        catch(Exception e) 
        {
            System.out.println("Deserialization failed");
            System.out.println();
        }

        loadWorldMatrix();
    }

    public void moveAll()
    {
        int j = (int) player.moveHorizontal();
        java.util.List l = getObjects(Block.class);

        for(int i = 0; i < l.size(); i++)
        {
            Block b = (Block) l.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }
        
        java.util.List k = getObjects(Armor.class);

        for(int x = 0; x < k.size(); x++)
        {            
            Items y = (Armor) k.get(x);
            if(y.statusGeben()==0){
                y.setLocation(y.getX() - j , y.getY());
            }        
        }
        
        java.util.List w = getObjects(Weapons.class);

        for(int x = 0; x < w.size(); x++)
        {
            Items p = (Weapons) w.get(x);
            if(p.statusGeben()==0){
                p.setLocation(p.getX() - j , p.getY());
            }
        }
        
        java.util.List f = getObjects(Potions.class);

        for(int x = 0; x < f.size(); x++)
        {            
            Items p = (Potions) f.get(x);
            if(p.statusGeben()==0){
                p.setLocation(p.getX() - j , p.getY());
            }
        }
        
        java.util.List m = getObjects(Hostile.class);

        for(int x = 0; x < m.size(); x++)
        {
            Hostile p = (Hostile) m.get(x);
            p.setLocation(p.getX() - j , p.getY());
        }
        
        java.util.List u = getObjects(Interactive.class);

        for(int i = 0; i < u.size(); i++)
        {
            Interactive b = (Interactive) u.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }
        
        java.util.List v = getObjects(Background.class);

        for(int i = 0; i < v.size(); i++)
        {
            Background b = (Background) v.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }
        
        java.util.List ship = getObjects(Buttons.class);
        
        for(int i = 0; i < ship.size(); i++)
        {
            Buttons s = (Buttons) ship.get(i);
            s.setLocation(s.getX() - j , s.getY());
        }  
        
        m = getObjects(Lootbag.class);
        
        for(int x = 0; x < m.size(); x++)
        {
            Lootbag lo = (Lootbag) m.get(x);
            lo.setLocation(lo.getX() - j , lo.getY());
        }
        
        m = getObjects(DeathAnimation.class);
        
        for(int x = 0; x < m.size(); x++)
        {
            DeathAnimation d = (DeathAnimation) m.get(x);
            d.setLocation(d.getX() - j , d.getY());
        }
    }

    public void setPlayer(Player p, Items[][] i, Items[] a)
    {
        this.player = p;
        removeObjects(getObjects(Player.class));
        addObject(p, 640, 350);
        p.aenderungSetzen();
        p.setFirstAct();
        p.setInventory(i);
        p.setAusger(a);
    }
    
    public void act()
    {
        moveAll();
    }

    public void prepareWorld(){
        showWorld();
    }

}