import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
public class Lootbag extends SmoothMover
{
    private int stufe;
    private boolean isPotion;
    private boolean looted = false;
    private double x;
    private double y;
    private double y2;
    private int timer;
    
    private GreenfootImage image1 = new GreenfootImage("g_lootbag_white.png");
    private GreenfootImage image2 = new GreenfootImage("g_lootbag_blue.png");
    private GreenfootImage image3 = new GreenfootImage("g_lootbag_orange.png");
    private GreenfootImage imageP = new GreenfootImage("g_lootbag_potion.png");
    public Lootbag(){
        stufe = 1;
        isPotion = false;
        setImage(image2);
        this.x = 640.0;
        this.y = 300.0;
    }
    
    public Lootbag(int stufe, boolean isPotion, double x, double y){
        if(stufe <= 3 && stufe > 0 && !isPotion){
            this.stufe = stufe;
            if(stufe == 1){
                setImage(image1);
            }
            if(stufe == 2){
                setImage(image2);
            }
            if(stufe == 3){
                setImage(image3);
            }
        }
        if(isPotion){
            setImage(imageP);
        }
        
        this.x = x;
        this.y = y;
        this.isPotion = isPotion;
    }
    
    public void act() 
    {
        move();
        loot();
        remove();
        timer++;
    }    
    //Löschen
    public void remove(){
        if(looted){
            getWorld().removeObject(this);
        }
        if(timer >= 50000){
            getWorld().removeObject(this);
        }
    }
    
    
    //Loot-Mechanik
    private void loot(){
        int item;
        int seltenheit;
        if(isTouching(HeroesPhys.class)){
            item = Greenfoot.getRandomNumber(22) + 3;
            seltenheit = getSeltenheit();
            if(!isPotion){
                List<Player> p = getWorld().getObjects(Player.class);
                Items i = new Items(item, seltenheit, 0);
                GreenfootImage image = new GreenfootImage("pointer.png");
                image.scale(1280,720);
                i.setImage(image);
                for(Player player : p){
                    getWorld().addObject(i, player.getX(), player.getY());
                }
            }
            
            else{
                int random = Greenfoot.getRandomNumber(6);
                List<Player> p = getWorld().getObjects(Player.class);
                for(Player player : p){
                    switch(random){
                        case 0 : getWorld().addObject(new add_stamina(0),player.getX(), player.getY()); break;
                        case 1 : getWorld().addObject(new Stamina(0),player.getX(), player.getY()); break;
                        case 2 : getWorld().addObject(new add_health(0),player.getX(), player.getY()); break;
                        case 3 : getWorld().addObject(new add_strength(0),player.getX(), player.getY()); break;
                        case 4 : getWorld().addObject(new Speed(0),player.getX(), player.getY()); break;
                        case 5 : getWorld().addObject(new Health(0),player.getX(), player.getY()); break;
                    }
                }
                
            }
            looted = true;
        }
        
    }
    
    private int getSeltenheit(){
       int seltenheit = 0;
       switch(stufe){
           case 1 : seltenheit = kiste1(); break;
           case 2 : seltenheit = kiste2(); break;
           case 3 : seltenheit = kiste3(); break;
       }
       return seltenheit;
    }
    
    private int kiste1(){
        int seltenheit = 5;
        int random = Greenfoot.getRandomNumber(100);
        if(random < 98){
            seltenheit = 4;
        }
        if(random < 93){
            seltenheit = 3;
        }
        if(random < 75){
            seltenheit = 2;
        }
        if(random < 55){
            seltenheit = 1;
        }
        if(random < 35){
            seltenheit = 0;
        }
        return seltenheit;
    }
    
    private int kiste2(){
        int seltenheit = 5;
        int random = Greenfoot.getRandomNumber(100);
        if(random < 90){
            seltenheit = 4;
        }
        if(random < 75){
            seltenheit = 3;
        }
        if(random < 55){
            seltenheit = 2;
        }
        if(random < 30){
            seltenheit = 1;
        }
        if(random < 15){
            seltenheit = 0;
        }
        return seltenheit;
    }
    
    private int kiste3(){
        int seltenheit = 5;
        int random = Greenfoot.getRandomNumber(100);
        if(random < 85){
            seltenheit = 4;
        }
        if(random < 65){
            seltenheit = 3;
        }
        if(random < 35){
            seltenheit = 2;
        }
        if(random < 15){
            seltenheit = 1;
        }
        if(random < 5){
            seltenheit = 0;
        }
        return seltenheit;
    }
    
    public void move(){
        y2 = y + 20 * Math.sin(0.05* timer);
        super.setLocation(getExactX(), y2);
    }
}
