import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.util.List.*;
/**
 * Write a description of class SafeZone here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SafeZone extends World
{
    private int[][] world;

    private int breite;
    private int höhe;

    private int xPos;
    //speichern
    private double x;
    private double y;
    private Player player = new Player();

    private String[][] worldMatrix;
    private int worldWidth;
    private int worldHeight;
    private int blocksize = 20;
    private String seed;
    private int counter = 0;
    private String seed_save = "";
    private Block start = new Block("1");
    private Block kräh = new Block("1000");
    private Block peter = new Block("1001");

    public SafeZone()
    {    
        super(1280, 720, 1, false);
        worldWidth = 800;
        worldHeight = 37;
        worldMatrix = new String[worldWidth][worldHeight];
        addObject(start, 0, 0);
        addObject(kräh, 1270, 618);
        addObject(peter, 2260, 658);
        setPaintOrder(Weapons.class,Armor.class,TeleportAnimation.class,HeroesPhys.class,Arm.class);
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                worldMatrix[x][y] = "";
            }
        }

        prepare();
        prepareWorld();
    }

    public void prepare()
    {
        loadScreen();
        Buttons c = new Buttons("h_tree_desert.png");
        addObject(c,50,550);
        Buttons d = new Buttons("h_tree_desert.png");
        addObject(d,2500,550);
        Buttons e = new Buttons("g_sign_red.png");
        addObject(e,2258,612); 
        Buttons f = new Buttons("g_chest_large.png");
        addObject(f,1570,576); 
        Buttons g = new Buttons("g_chest_small.png");
        addObject(g,1590,591); 
        Buttons h = new Buttons("g_chest_small.png");
        addObject(h,1630,591); 
        Buttons i = new Buttons("g_chest_small.png");
        addObject(i,1620,551); 
        Buttons b = new Buttons("h_teleportpad.png");
        addObject(b,1290,600);
        Buttons j = new Buttons("h_purple_tent.png");
        addObject(j,1110,560);
        Buttons k = new Buttons("h_purple_tent.png");
        addObject(k,1430,560);
        Buttons l = new Buttons("g_desert_grass.png");
        addObject(l,230,630);
        Buttons m = new Buttons("g_desert_grass.png");
        addObject(m,130,630);
        Buttons n = new Buttons("g_desert_grass.png");
        addObject(n,2390,630);
        Buttons o = new Buttons("g_desert_grass.png");
        addObject(o,2630,630);
        Buttons q = new Buttons("g_desert_grass.png");
        addObject(q,2680,630);
        Buttons r = new Buttons("g_desert_bush_2.png");
        addObject(r,380,630);
        Buttons s = new Buttons("g_desert_bush_2.png");
        addObject(s,2740,632);
        Buttons t = new Buttons("h_tree.png");
        addObject(t,620,550);
        Buttons u = new Buttons("h_tree.png");
        addObject(u,1790,530);
        addObject(player, 640,618); 
        addObject(new sounds(),0,0);
    }

    public String convertSeed()
    {
        String seed_sub = "";
        String seed_write = "";

        seed_sub = seed.substring(counter, counter+1);
        seed_save = seed_save + seed_sub;
        counter = counter+1;
        seed_sub = (String) seed.substring(counter, counter+1);

        if(seed_sub.equals("/"))
        {
            seed_write = seed_save;
            seed_save = "";
            counter++;
            return seed_write;
        }
        else
        {
            return convertSeed();
        }
    }

    public void loadWorldMatrix()
    {
        String seed_sub = "";
        String seed_save = "";
        String seed_matrix = "";

        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                seed_matrix = convertSeed();
                if(seed_matrix.equals("0"))
                {
                    worldMatrix[x][y] = "";
                }
                else
                {
                    worldMatrix[x][y] = seed_matrix;
                }
            }
        }

        counter = 0;
        setWorld();
    }

    public void setWorld()
    {        
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                if(!worldMatrix[x][y].equals(""))
                {
                    Block block = new Block(worldMatrix[x][y]);
                    int height = block.getHeight();
                    int width = block.getWidth();
                    int width_round = (int) Math.round(width/blocksize + 0.5) * blocksize;
                    int height_round = (int) Math.round(height/blocksize + 0.5) * blocksize;
                    int width_adjusted = (blocksize - (width_round - width))*2;
                    int height_adjusted = (blocksize - (height_round - height))*2;

                    if(Integer.parseInt(worldMatrix[x][y]) < 200)
                    {
                        addObject(new Block(worldMatrix[x][y]), x*blocksize, y*blocksize);
                    }
                    else
                    {
                        if((height % blocksize) == 0)
                        {
                            addObject(new Block(worldMatrix[x][y]), x*blocksize +blocksize/2, y*blocksize +blocksize/2);
                        }
                        else
                        {
                            addObject(block, x*blocksize - width_adjusted + blocksize, y*blocksize + height_adjusted);
                        } 
                    }
                }
            }
        }
    }

    public void showWorld(){

        for(int x = 0; x < breite; x++){
            for(int y = 0; y < höhe; y++){
                int block = world[x][y];
                int xCoord = x * 20 + 10;
                int yCoord = y * 20 + 10;

                switch(block){
                    case 0 : break;
                    default : addObject(new Block(Integer.toString(block)),xCoord, yCoord ); break;

                }
            }
        }
    }

    public void loadScreen()
    {     
        try
        {
            seed = "";
            ObjectInputStream seed_in = new ObjectInputStream(new FileInputStream("Safezone" + ".txt"));
            seed = (String) seed_in.readObject();
            seed_in.close();
        }
        catch(Exception e) 
        {
            System.out.println("Deserialization failed");
            System.out.println();
        }

        loadWorldMatrix();
    }
    
        public void moveAll(){
        int j = (int) player.moveHorizontal();
        moveAll(j); 
        
    }

    public void moveAll(int q)
    {
        int j = q;
        java.util.List l = getObjects(Block.class);

        for(int i = 0; i < l.size(); i++)
        {
            Block b = (Block) l.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }
        java.util.List k = getObjects(Armor.class);

        for(int x = 0; x < k.size(); x++)
        {            
            Items y = (Armor) k.get(x);
            if(y.statusGeben()==0){
                y.setLocation(y.getX() - j , y.getY());
            }        
        }
        java.util.List w = getObjects(Weapons.class);

        for(int x = 0; x < w.size(); x++)
        {
            Items p = (Weapons) w.get(x);
            if(p.statusGeben()==0){
                p.setLocation(p.getX() - j , p.getY());
            }
        }

        java.util.List f = getObjects(Potions.class);

        for(int x = 0; x < f.size(); x++)
        {            
            Items p = (Potions) f.get(x);
            if(p.statusGeben()==0){
                p.setLocation(p.getX() - j , p.getY());
            }
        }

        java.util.List m = getObjects(Hostile.class);

        for(int x = 0; x < m.size(); x++)
        {
            Hostile p = (Hostile) m.get(x);
            p.setLocation(p.getX() - j , p.getY());
        }
        
        java.util.List u = getObjects(Interactive.class);

        for(int i = 0; i < u.size(); i++)
        {
            Interactive b = (Interactive) u.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }
        
        java.util.List ship = getObjects(Buttons.class);
        
        for(int i = 0; i < ship.size(); i++)
        {
            Buttons s = (Buttons) ship.get(i);
            s.setLocation(s.getX() - j , s.getY());
        } 
        
        m = getObjects(Background.class);

        for(int x = 0; x < m.size(); x++)
        {
            Background b = (Background) m.get(x);
            b.setLocation(b.getX() - j , b.getY());
        }
        m = getObjects(DeathAnimation.class);
        
        for(int x = 0; x < m.size(); x++)
        {
            DeathAnimation d = (DeathAnimation) m.get(x);
            d.setLocation(d.getX() - j , d.getY());
        }
    }

    public void setPlayer(Player p, Items[][] i, Items[] a)
    {
        this.player = p;
        removeObjects(getObjects(Player.class));
        addObject(p, 640, 350);
        p.aenderungSetzen();
        p.setFirstAct();
        p.setInventory(i);
        p.setAusger(a);
    }
    
    public void act()
    {
        moveAll();
    }

    public void prepareWorld(){
        showWorld();
    }

}
