import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
public class ShipWorld extends World
{

    private String[][] worldMatrix;
    private int worldWidth;
    private int worldHeight;
    private int blocksize = 20;
    private String seed;
    private int counter = 0;
    private String seed_save = "";
    private Block start = new Block("1");
    private Player player = new Player();
    private Block hubert = new Block("1002");
    private Block hanibal = new Block("1010");
    public ShipWorld()
    {    
        super(1280, 720, 1, false);
        worldWidth = 800;
        worldHeight = 37;
        worldMatrix = new String[worldWidth][worldHeight];
        addObject(start, 0, 0);
        addObject(new sounds(),0,0);
        setPaintOrder(Weapons.class,Armor.class, HeroesPhys.class,Arm.class);
        
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                worldMatrix[x][y] = "";
            }
        }
        
        prepare();
    }
    
    public void prepare()
    {
        addObject(hanibal,830,458);
        loadScreen();
        Buttons b = new Buttons("h_ship_blue_HD.png");
        addObject(hubert, 640, 458);
        addObject(b, 640,360);   
        addObject(player, 640,415);
        //addObject(new Interactive(), 670, 400);
        //addObject(new Block("2"), 675, 395);
    }
    
    public String convertSeed()
    {
        String seed_sub = "";
        String seed_write = "";
        
        seed_sub = seed.substring(counter, counter+1);
        seed_save = seed_save + seed_sub;
        counter = counter+1;
        seed_sub = (String) seed.substring(counter, counter+1);
        
        if(seed_sub.equals("/"))
        {
            seed_write = seed_save;
            seed_save = "";
            counter++;
            return seed_write;
        }
        else
        {
            return convertSeed();
        }
    }
    
    public void loadWorldMatrix()
    {
        String seed_sub = "";
        String seed_save = "";
        String seed_matrix = "";
                
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                seed_matrix = convertSeed();
                if(seed_matrix.equals("0"))
                {
                    worldMatrix[x][y] = "";
                }
                else
                {
                    worldMatrix[x][y] = seed_matrix;
                }
            }
        }
                
        counter = 0;
        setWorld();
    }
    
    public void setWorld()
    {        
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                if(!worldMatrix[x][y].equals(""))
                {
                    Block block = new Block(worldMatrix[x][y]);
                    int height = block.getHeight();
                    int width = block.getWidth();
                    int width_round = (int) Math.round(width/blocksize + 0.5) * blocksize;
                    int height_round = (int) Math.round(height/blocksize + 0.5) * blocksize;
                    int width_adjusted = (blocksize - (width_round - width))*2;
                    int height_adjusted = (blocksize - (height_round - height))*2;
                
                    if(Integer.parseInt(worldMatrix[x][y]) < 200)
                    {
                        addObject(new Block(worldMatrix[x][y]), x*blocksize, y*blocksize);
                    }
                    else
                    {
                        if((height % blocksize) == 0)
                        {
                            addObject(new Block(worldMatrix[x][y]), x*blocksize +blocksize/2, y*blocksize +blocksize/2);
                        }
                        else
                        {
                            addObject(block, x*blocksize - width_adjusted + blocksize, y*blocksize + height_adjusted);
                        } 
                    }
                }
            }
        }
    }
    
    public void loadScreen()
    {     
        try
        {
            seed = "";
            ObjectInputStream seed_in = new ObjectInputStream(new FileInputStream("LEVEL1" + ".txt"));
            seed = (String) seed_in.readObject();
            seed_in.close();
        }
        catch(Exception e) 
        {
            System.out.println("Deserialization failed");
            System.out.println();
        }
        
        loadWorldMatrix();
    }
    
    public void moveAll()
    {
       int j = (int) player.moveHorizontal();
        java.util.List l = getObjects(Block.class);

        for(int i = 0; i < l.size(); i++)
        {
            Block b = (Block) l.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }
        java.util.List k = getObjects(Armor.class);

        for(int x = 0; x < k.size(); x++)
        {            
            Items y = (Armor) k.get(x);
            if(y.statusGeben()==0){
                y.setLocation(y.getX() - j , y.getY());
            }        
        }
        java.util.List w = getObjects(Weapons.class);

        for(int x = 0; x < w.size(); x++)
        {
            Items p = (Weapons) w.get(x);
            if(p.statusGeben()==0){
                p.setLocation(p.getX() - j , p.getY());
            }
        }

        java.util.List f = getObjects(Potions.class);

        for(int x = 0; x < f.size(); x++)
        {            
            Items p = (Potions) f.get(x);
            if(p.statusGeben()==0){
                p.setLocation(p.getX() - j , p.getY());
            }
        }

        java.util.List m = getObjects(Hostile.class);

        for(int x = 0; x < m.size(); x++)
        {
            Hostile p = (Hostile) m.get(x);
            p.setLocation(p.getX() - j , p.getY());
        }
        
        java.util.List u = getObjects(Interactive.class);

        for(int i = 0; i < u.size(); i++)
        {
            Interactive b = (Interactive) u.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }
        
        java.util.List ship = getObjects(Buttons.class);
        
        for(int i = 0; i < ship.size(); i++)
        {
            Buttons s = (Buttons) ship.get(i);
            s.setLocation(s.getX() - j , s.getY());
        } 
    }
    
    public void setPlayer(Player p, Items[][] i, Items[] a)
    {
        this.player = p;
        removeObjects(getObjects(Player.class));
        addObject(p, 640, 350);
        p.aenderungSetzen();
        p.setFirstAct();
        p.setInventory(i);
        p.setAusger(a);
    }
    
    public void act()
    {
        moveAll();
    }
}
