import greenfoot.*;
import java.io.*;
import java.util.List.*;

public class Storylevel extends World
{
    private String[][] worldMatrix;
    private int worldWidth;
    private int worldHeight;
    private int blocksize = 20;
    private String seed;
    private int counter = 0;
    private String seed_save = "";
    private Block start = new Block("1");
    private Player p;
    
    public Storylevel()
    {    
        super(1280, 720, 1, false);
        worldWidth = 800;
        worldHeight = 37;
        worldMatrix = new String[worldWidth][worldHeight];
        addObject(start, 0, 0);
        
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                worldMatrix[x][y] = "";
            }
        }
        
        prepare();
    }
    
    public void prepare()
    {
        loadScreen();
        p = new Player();
        addObject(p, 640,400);
        addObject(new Interactive(), 670, 400);
        addObject(new Block("2"), 675, 395);
    }
    
    public String convertSeed()
    {
        String seed_sub = "";
        String seed_write = "";
        
        seed_sub = seed.substring(counter, counter+1);
        seed_save = seed_save + seed_sub;
        counter = counter+1;
        seed_sub = (String) seed.substring(counter, counter+1);
        
        if(seed_sub.equals("/"))
        {
            seed_write = seed_save;
            seed_save = "";
            counter++;
            return seed_write;
        }
        else
        {
            return convertSeed();
        }
    }
    
    public void loadWorldMatrix()
    {
        String seed_sub = "";
        String seed_save = "";
        String seed_matrix = "";
                
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                seed_matrix = convertSeed();
                if(seed_matrix.equals("0"))
                {
                    worldMatrix[x][y] = "";
                }
                else
                {
                    worldMatrix[x][y] = seed_matrix;
                }
            }
        }
                
        counter = 0;
        setWorld();
    }
    
    public void setWorld()
    {        
        for(int x = 0; x < worldWidth; x++)
        {
            for(int y = 0; y < worldHeight; y++)
            {
                if(!worldMatrix[x][y].equals(""))
                {
                    Block block = new Block(worldMatrix[x][y]);
                    int height = block.getHeight();
                    int width = block.getWidth();
                    int width_round = (int) Math.round(width/blocksize + 0.5) * blocksize;
                    int height_round = (int) Math.round(height/blocksize + 0.5) * blocksize;
                    int width_adjusted = (blocksize - (width_round - width))*2;
                    int height_adjusted = (blocksize - (height_round - height))*2;
                
                    if(Integer.parseInt(worldMatrix[x][y]) < 200)
                    {
                        addObject(new Block(worldMatrix[x][y]), x*blocksize, y*blocksize);
                    }
                    else
                    {
                        if((height % blocksize) == 0)
                        {
                            addObject(new Block(worldMatrix[x][y]), x*blocksize +blocksize/2, y*blocksize +blocksize/2);
                        }
                        else
                        {
                            addObject(block, x*blocksize - width_adjusted + blocksize, y*blocksize + height_adjusted);
                        } 
                    }
                }
            }
        }
    }
    
    public void loadScreen()
    {     
        try
        {
            seed = "";
            ObjectInputStream seed_in = new ObjectInputStream(new FileInputStream("LEVEL1" + ".txt"));
            seed = (String) seed_in.readObject();
            seed_in.close();
        }
        catch(Exception e) 
        {
            System.out.println("Deserialization failed");
            System.out.println();
        }
        
        loadWorldMatrix();
    }
    
    public void moveAll()
    {
        int j = (int) p.moveHorizontal();
        java.util.List l = getObjects(Block.class);

        for(int i = 0; i < l.size(); i++)
        {
            Block b = (Block) l.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }
        
        java.util.List u = getObjects(Interactive.class);
        
        for(int i = 0; i < u.size(); i++)
        {
            Interactive b = (Interactive) u.get(i);
            b.setLocation(b.getX() - j , b.getY());
        }
        
        java.util.List l2 = getObjects(Subjects.class);

        for(int i2 = 0; i2 < l2.size(); i2++)
        {
            Subjects b2 = (Subjects) l2.get(i2);
            b2.setLocation(b2.getX() - j , b2.getY());
        }
    }
    
    public void act()
    {
        moveAll();
    }
    
}
